Package com.fasterxml.jackson.core

# Class Version

java.lang.Object
com.fasterxml.jackson.core.Version

All Implemented Interfaces:
  `Serializable`, `Comparable<Version>`

public class Version extends Object implements Comparable<Version>, Serializable
Object that encapsulates versioning information of a component. Version information includes not just version number but also optionally group and artifact ids of the component being versioned.

Note that optional group and artifact id properties are new with Jackson 2.0: if provided, they should align with Maven artifact information.

See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final String`
`_artifactId`
`protected final String`
`_groupId`
`protected final int`
`_majorVersion`
`protected final int`
`_minorVersion`
`protected final int`
`_patchLevel`
`protected final String`
`_snapshotInfo`
Additional information for snapshot versions; null for non-snapshot (release) versions.

## Constructor Summary

Constructors
Constructor
Description
`Version(int major, int minor, int patchLevel, String snapshotInfo)`
Deprecated.
Use variant that takes group and artifact ids
`Version(int major, int minor, int patchLevel, String snapshotInfo, String groupId, String artifactId)`

## Method Summary

Modifier and Type
Method
Description
`int`
`compareTo(Version other)`
`boolean`
`equals(Object o)`
`String`
`getArtifactId()`
`String`
`getGroupId()`
`int`
`getMajorVersion()`
`int`
`getMinorVersion()`
`int`
`getPatchLevel()`
`int`
`hashCode()`
`boolean`
`isSnapshot()`
`boolean`
`isUknownVersion()`
Deprecated.
Since 2.7 use correctly spelled method `isUnknownVersion()`
`boolean`
`isUnknownVersion()`
`String`
`toFullString()`
`String`
`toString()`
`static Version`
`unknownVersion()`
Method returns canonical "not known" version, which is used as version in cases where actual version information is not known (instead of null).

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### _majorVersion

protected final int _majorVersion

### _minorVersion

protected final int _minorVersion

### _patchLevel

protected final int _patchLevel

### _groupId

protected final String _groupId

### _artifactId

protected final String _artifactId

### _snapshotInfo

protected final String _snapshotInfo
Additional information for snapshot versions; null for non-snapshot (release) versions.

## Constructor Details

### Version

@Deprecated public Version(int major, int minor, int patchLevel, String snapshotInfo)
Deprecated.
Use variant that takes group and artifact ids

Parameters:
  `major` - Major version number
  `minor` - Minor version number
  `patchLevel` - patch level of version
  `snapshotInfo` - Optional additional string qualifier
Since:
  2.1

### Version

public Version(int major, int minor, int patchLevel, String snapshotInfo, String groupId, String artifactId)

## Method Details

### unknownVersion

public static Version unknownVersion()
Method returns canonical "not known" version, which is used as version in cases where actual version information is not known (instead of null).

Returns:
  Version instance to use as a placeholder when actual version is not known (or not relevant)

### isUnknownVersion

public boolean isUnknownVersion()

Returns:
  `True` if this instance is the one returned by call to `unknownVersion()`
Since:
  2.7 to replace misspelled `isUknownVersion()`

### isSnapshot

public boolean isSnapshot()

### isUknownVersion

@Deprecated public boolean isUknownVersion()
Deprecated.
Since 2.7 use correctly spelled method `isUnknownVersion()`

Returns:
  `True` if this instance is the one returned by call to `unknownVersion()`

### getMajorVersion

public int getMajorVersion()

### getMinorVersion

public int getMinorVersion()

### getPatchLevel

public int getPatchLevel()

### getGroupId

public String getGroupId()

### getArtifactId

public String getArtifactId()

### toFullString

public String toFullString()

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### hashCode

public int hashCode()

Overrides:
  `hashCode` in class `Object`

### equals

public boolean equals(Object o)

Overrides:
  `equals` in class `Object`

### compareTo

public int compareTo(Version other)

Specified by:
  `compareTo` in interface `Comparable<Version>`